#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "Fish_GiftCFG.h"
std::auto_ptr<Fish_GiftCFG> Fish_GiftCFG::msSingleton(nullptr);

int Fish_GiftCFG::GetCount()
{
	return (int)mMapData.size();
}

const Fish_GiftCFGData* Fish_GiftCFG::GetData(int Turret)
{
	auto it = mMapData.find(Turret);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, Fish_GiftCFGData>& Fish_GiftCFG::GetMapData()
{
	return mMapData;
}

void Fish_GiftCFG::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/Fish_GiftCFG.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		Fish_GiftCFGData data;
		data.mTurret = element->IntAttribute("Turret");
		data.mItemID = element->IntAttribute("ItemID");
		data.mItemCount = element->IntAttribute("ItemCount");
		if (mMapData.find(data.mTurret) != mMapData.end())std::cout <<"data refind:" << data.mTurret << std::endl;
		CCASSERT(mMapData.find(data.mTurret) == mMapData.end(), "data.mTurret is exists");
		mMapData.insert(std::make_pair(data.mTurret, data));
		element = element->NextSiblingElement();
	}
	CCLOG("Fish_GiftCFG Loaded. Load Data:%u", mMapData.size());
}

void Fish_GiftCFG::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/Fish_GiftCFG");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "Fish_GiftCFG");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		Fish_GiftCFGData data;
		LuaCfgHelper::readInt(L, "Turret", data.mTurret);
		LuaCfgHelper::readInt(L, "ItemID", data.mItemID);
		LuaCfgHelper::readInt(L, "ItemCount", data.mItemCount);
		if (mMapData.find(data.mTurret) != mMapData.end())std::cout <<"data refind:" << data.mTurret << std::endl;
		CCASSERT(mMapData.find(data.mTurret) == mMapData.end(), "data.mTurret is exists");
		mMapData.insert(std::make_pair(data.mTurret, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("Fish_GiftCFG Loaded. Load Data:%u", mMapData.size());
}

void Fish_GiftCFG::Reload()
{
	mMapData.clear();
	Load();
}

Fish_GiftCFG* Fish_GiftCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new Fish_GiftCFG());
	}
	return msSingleton.get();
}

void Fish_GiftCFG::Release()
{
	msSingleton.reset(nullptr);
}
